diff --git a/manual/examples/add.c b/manual/examples/add.c
index 88d3e3d5f7..5b502c6467 100644
--- a/manual/examples/add.c
+++ b/manual/examples/add.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdarg.h>
diff --git a/manual/examples/argp-ex1.c b/manual/examples/argp-ex1.c
index 900af1aec9..2b76129087 100644
--- a/manual/examples/argp-ex1.c
+++ b/manual/examples/argp-ex1.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 /* This is (probably) the smallest possible program that
diff --git a/manual/examples/argp-ex2.c b/manual/examples/argp-ex2.c
index 2465d418a8..50faf6b36a 100644
--- a/manual/examples/argp-ex2.c
+++ b/manual/examples/argp-ex2.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 /* This program doesn't use any options or arguments, but uses
diff --git a/manual/examples/argp-ex3.c b/manual/examples/argp-ex3.c
index efec8e8507..76d658a81e 100644
--- a/manual/examples/argp-ex3.c
+++ b/manual/examples/argp-ex3.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 /* This program uses the same features as example 2, and uses options and
diff --git a/manual/examples/argp-ex4.c b/manual/examples/argp-ex4.c
index f560e38bfb..4b38f03896 100644
--- a/manual/examples/argp-ex4.c
+++ b/manual/examples/argp-ex4.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 /* This program uses the same features as example 3, but has more
diff --git a/manual/examples/atexit.c b/manual/examples/atexit.c
index 718651e8bd..57def3b8c7 100644
--- a/manual/examples/atexit.c
+++ b/manual/examples/atexit.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/db.c b/manual/examples/db.c
index 93602dece5..ec60cd72af 100644
--- a/manual/examples/db.c
+++ b/manual/examples/db.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <grp.h>
diff --git a/manual/examples/dir.c b/manual/examples/dir.c
index f9d314a780..a7d37717da 100644
--- a/manual/examples/dir.c
+++ b/manual/examples/dir.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 /*@group*/
diff --git a/manual/examples/dir2.c b/manual/examples/dir2.c
index 1403bb4ea9..bba417dea8 100644
--- a/manual/examples/dir2.c
+++ b/manual/examples/dir2.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 /*@group*/
diff --git a/manual/examples/execinfo.c b/manual/examples/execinfo.c
index 112134a70e..2d82625b6c 100644
--- a/manual/examples/execinfo.c
+++ b/manual/examples/execinfo.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <execinfo.h>
diff --git a/manual/examples/filecli.c b/manual/examples/filecli.c
index dcdb82590d..89b862655e 100644
--- a/manual/examples/filecli.c
+++ b/manual/examples/filecli.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/filesrv.c b/manual/examples/filesrv.c
index 7d9f507be2..c4a4998168 100644
--- a/manual/examples/filesrv.c
+++ b/manual/examples/filesrv.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/fmtmsgexpl.c b/manual/examples/fmtmsgexpl.c
index 8c1e058204..328e98be1c 100644
--- a/manual/examples/fmtmsgexpl.c
+++ b/manual/examples/fmtmsgexpl.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <fmtmsg.h>
diff --git a/manual/examples/genpass.c b/manual/examples/genpass.c
index 23d20789fc..e729dd29ab 100644
--- a/manual/examples/genpass.c
+++ b/manual/examples/genpass.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/inetcli.c b/manual/examples/inetcli.c
index bcc060b7ca..0718480dd8 100644
--- a/manual/examples/inetcli.c
+++ b/manual/examples/inetcli.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/inetsrv.c b/manual/examples/inetsrv.c
index ea590fe7b8..249457b5ec 100644
--- a/manual/examples/inetsrv.c
+++ b/manual/examples/inetsrv.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/isockad.c b/manual/examples/isockad.c
index 4a55e7a696..2bc4f5e744 100644
--- a/manual/examples/isockad.c
+++ b/manual/examples/isockad.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/longopt.c b/manual/examples/longopt.c
index 4f33d52558..698caf0a1d 100644
--- a/manual/examples/longopt.c
+++ b/manual/examples/longopt.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/memopen.c b/manual/examples/memopen.c
index 7ffd06b3eb..b71607c68f 100644
--- a/manual/examples/memopen.c
+++ b/manual/examples/memopen.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/memstrm.c b/manual/examples/memstrm.c
index 65147c8734..5c57fdd02d 100644
--- a/manual/examples/memstrm.c
+++ b/manual/examples/memstrm.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/mkdirent.c b/manual/examples/mkdirent.c
index cb19c1f3cc..445dd0fe93 100644
--- a/manual/examples/mkdirent.c
+++ b/manual/examples/mkdirent.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <dirent.h>
diff --git a/manual/examples/mkfsock.c b/manual/examples/mkfsock.c
index ebce75f4bf..6865449656 100644
--- a/manual/examples/mkfsock.c
+++ b/manual/examples/mkfsock.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stddef.h>
diff --git a/manual/examples/mkisock.c b/manual/examples/mkisock.c
index 1a13c54271..eaf316ea34 100644
--- a/manual/examples/mkisock.c
+++ b/manual/examples/mkisock.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/mygetpass.c b/manual/examples/mygetpass.c
index 3f465ac8ea..65c732cfed 100644
--- a/manual/examples/mygetpass.c
+++ b/manual/examples/mygetpass.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <termios.h>
diff --git a/manual/examples/pipe.c b/manual/examples/pipe.c
index 25fed7f754..71a25ed078 100644
--- a/manual/examples/pipe.c
+++ b/manual/examples/pipe.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <sys/types.h>
diff --git a/manual/examples/popen.c b/manual/examples/popen.c
index 566dbf3918..e6ac3bf1fd 100644
--- a/manual/examples/popen.c
+++ b/manual/examples/popen.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/rprintf.c b/manual/examples/rprintf.c
index 917db0866a..9f31fa28bd 100644
--- a/manual/examples/rprintf.c
+++ b/manual/examples/rprintf.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/search.c b/manual/examples/search.c
index 624cf50290..9d43c84cd3 100644
--- a/manual/examples/search.c
+++ b/manual/examples/search.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdlib.h>
diff --git a/manual/examples/select.c b/manual/examples/select.c
index 2a92d5358f..fe9999e354 100644
--- a/manual/examples/select.c
+++ b/manual/examples/select.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 /*@group*/
diff --git a/manual/examples/setjmp.c b/manual/examples/setjmp.c
index cc9ccc7663..47d6a3e1ae 100644
--- a/manual/examples/setjmp.c
+++ b/manual/examples/setjmp.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <setjmp.h>
diff --git a/manual/examples/sigh1.c b/manual/examples/sigh1.c
index 9fe0fd2394..3dbe82658b 100644
--- a/manual/examples/sigh1.c
+++ b/manual/examples/sigh1.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <signal.h>
diff --git a/manual/examples/sigusr.c b/manual/examples/sigusr.c
index 7dfb4cf251..6a92567262 100644
--- a/manual/examples/sigusr.c
+++ b/manual/examples/sigusr.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 /*@group*/
diff --git a/manual/examples/stpcpy.c b/manual/examples/stpcpy.c
index ab0befdf58..542f1930f6 100644
--- a/manual/examples/stpcpy.c
+++ b/manual/examples/stpcpy.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <string.h>
diff --git a/manual/examples/strdupa.c b/manual/examples/strdupa.c
index 7dc4180cf1..a8d108af68 100644
--- a/manual/examples/strdupa.c
+++ b/manual/examples/strdupa.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <paths.h>
diff --git a/manual/examples/strftim.c b/manual/examples/strftim.c
index 2b7e48a1c9..1120f3421f 100644
--- a/manual/examples/strftim.c
+++ b/manual/examples/strftim.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <time.h>
diff --git a/manual/examples/subopt.c b/manual/examples/subopt.c
index a3fba4b537..b04b004201 100644
--- a/manual/examples/subopt.c
+++ b/manual/examples/subopt.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/swapcontext.c b/manual/examples/swapcontext.c
index d0b7b2b374..13cd207eb0 100644
--- a/manual/examples/swapcontext.c
+++ b/manual/examples/swapcontext.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <signal.h>
diff --git a/manual/examples/termios.c b/manual/examples/termios.c
index e4e5a5540c..115e524c26 100644
--- a/manual/examples/termios.c
+++ b/manual/examples/termios.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <unistd.h>
diff --git a/manual/examples/testopt.c b/manual/examples/testopt.c
index 6249f2a2ed..8bffc5238f 100644
--- a/manual/examples/testopt.c
+++ b/manual/examples/testopt.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 /*@group*/
diff --git a/manual/examples/testpass.c b/manual/examples/testpass.c
index f8883fea17..0b8e8a5377 100644
--- a/manual/examples/testpass.c
+++ b/manual/examples/testpass.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 #include <stdio.h>
diff --git a/manual/examples/timeval_subtract.c b/manual/examples/timeval_subtract.c
index 77265bb252..aeb0c39bc7 100644
--- a/manual/examples/timeval_subtract.c
+++ b/manual/examples/timeval_subtract.c
@@ -12,7 +12,7 @@
    GNU General Public License for more details.
 
    You should have received a copy of the GNU General Public License
-   along with this program; if not, if not, see <http://www.gnu.org/licenses/>.
+   along with this program; if not, see <http://www.gnu.org/licenses/>.
 */
 
 /* Subtract the `struct timeval' values X and Y,